/*
 Δραστηριότητα 1.16
 Τηλεχειριστήριο IR και έλγεχος LED
*/
#include <IRremote.h>

int RECV_PIN = A0;
int LED_PIN = 3;
int ledState = LOW;
unsigned long previousMillis = 0;
const long interval = 100;  // διάστημα για το αναβοσβήσιμο σε ms
bool speedMode = false;     // μεταβλητή για να κρατάει την κατάσταση της λειτουργίας ταχύτητας
int brightness = 255;       // αρχική φωτεινότητα του LED

void setup() {
  Serial.begin(9600);
  IrReceiver.begin(RECV_PIN);
  pinMode(LED_PIN, OUTPUT);
}

void loop() {
  if (IrReceiver.decode()) {
    if (IrReceiver.decodedIRData.command == 64) { // Όταν πατηθεί το "ΟΚ" στο χειριστήριο
      if (ledState == LOW) {
        ledState = HIGH;
        brightness = 255;
      } else {
        ledState = LOW;
        brightness = 0;
        speedMode = false;
      }
      digitalWrite(LED_PIN, ledState);
      analogWrite(LED_PIN, brightness);
      delay(50);
    } else if (IrReceiver.decodedIRData.command == 70)  // Όταν πατηθεί το πάνω βελάκι στο χειριστήριο ενεργοποιείται το speedmode
    {
      speedMode = true;
    } else if (IrReceiver.decodedIRData.command == 21)  // Όταν πατηθεί το κάτω βελάκι στο χειριστήριο απενεργοποιείται το speedmode
    {
      speedMode = false;
    }
    IrReceiver.resume();
  }

  if (ledState == HIGH && !speedMode) {
    unsigned long currentMillis = millis();
    if (currentMillis - previousMillis >= interval) {
      previousMillis = currentMillis;
      if (brightness == 0) {
        brightness = 255;
      } else {
        brightness = 0;
      }
      analogWrite(LED_PIN, brightness);
    }
  } else if (ledState == HIGH && speedMode) {
    unsigned long currentMillis = millis();
    if (currentMillis - previousMillis >= interval / 2) {
      previousMillis = currentMillis;
      if (brightness == 0) {
        brightness = 255;
      } else {
        brightness = 0;
      }
      analogWrite(LED_PIN, brightness);
    }
  }
}
