/*
  Δραστηριότητα 1.25
  Σχεδιασμός κατα της πτώσης και ηχητική ειδοποίηση
*/
#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x47);
int speed = 1000;      // Αρχικοποίηση της τιμής της ταχύτητας
int turnSpeed = 2000;  // Αρχικοποίηση της ταχύτητας για τις μεθόδους στροφής
int BUZZER_PIN = 2;     // Ορισμός του βομβητή στο pin του.

#define SensorLeft 6    // καρφίτσα εισαγωγής του αριστερού αισθητήρα
#define SensorMiddle 7  // καρφίτσα εισαγωγής του μεσαίου αισθητήρα
#define SensorRight 8   // καρφίτσα εισαγωγής του δεξιού αισθητήρα

unsigned char SL;  // κατάσταση αριστερού αισθητήρα
unsigned char SM;  // κατάσταση μεσαίου αισθητήρα
unsigned char SR;  // κατάσταση δεξιού αισθητήρα

void setup() {
  Serial.begin(9600);  // Έναρξη σειριακής θύρας στη συχνότητα 9600bit.
  pwm.begin();
  pwm.setPWMFreq(60);  // ρυθμίστε τον αισθητήρα παρακολούθησης γραμμής σε λειτουργία εισόδου
  pinMode(SensorLeft, INPUT);
  pinMode(SensorMiddle, INPUT);
  pinMode(SensorRight, INPUT);
  stop();  // Το αυτοκίνητο σταματάει
}

void loop() {
  // ανάγνωση των τιμών του αισθητήρα παρακολούθησης γραμμής
  SL = digitalRead(SensorLeft);
  SM = digitalRead(SensorMiddle);
  SR = digitalRead(SensorRight);
  //  αν το σήμα και από τους 3 σένσορες είναι χαμηλό, το αυτοκίνητο κινείται προς τα εμπρός
  if (SM == LOW && SL == LOW && SR == LOW) {
    advance();
  } else {
    digitalWrite(BUZZER_PIN, HIGH);
    back();
    delay(500);
    turnR();
    delay(500);
    digitalWrite(BUZZER_PIN, LOW);
  }
}

void advance()  // Κίνηση μπροστά
{
  pwm.setPWM(0, 0, speed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, speed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, speed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, speed);
  pwm.setPWM(7, 0, 0);
}

void turnR()  // Στροφή δεξιά
{
  pwm.setPWM(0, 0, turnSpeed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, turnSpeed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, turnSpeed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, turnSpeed);
}

void turnL()  // Στροφή αριστερά
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, turnSpeed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, turnSpeed);
  pwm.setPWM(4, 0, turnSpeed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, turnSpeed);
  pwm.setPWM(7, 0, 0);
}

void stop()  // Σταματάει
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, 0);
}

void back()  // Κίνηση προς τα πίσω
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, speed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, speed);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, speed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, speed);
}