/*
 Δραστηριότητα 1.26
 Παρακολούθηση γραμμής έξυπνου αυτοκινήτου
*/
#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x47);

int speed = 1000;      // Αρχικοποίηση της τιμής της ταχύτητας
int turnSpeed = 2000;  // Αρχικοποίηση της ταχύτητας για τις μεθόδους στροφής

#define SensorLeft 6    // καρφίτσα εισαγωγής του αριστερού αισθητήρα
#define SensorMiddle 7  // καρφίτσα εισαγωγής του μεσαίου αισθητήρα
#define SensorRight 8   // καρφίτσα εισαγωγής του δεξιού αισθητήρα

unsigned char SL;  // κατάσταση αριστερού αισθητήρα
unsigned char SM;  // κατάσταση μεσαίου αισθητήρα
unsigned char SR;  // κατάσταση δεξιού αισθητήρα

void setup() {
  Serial.begin(9600);  // Έναρξη σειριακής θύρας στη συχνότητα 9600bit
  pwm.begin();
  pwm.setPWMFreq(60);
  pinMode(SensorLeft, INPUT);
  pinMode(SensorMiddle, INPUT);
  pinMode(SensorRight, INPUT);
  stop();
}

void loop() {
  // ανάγνωση των τιμών του αισθητήρα παρακολούθησης γραμμής
  SL = digitalRead(SensorLeft);
  SM = digitalRead(SensorMiddle);
  SR = digitalRead(SensorRight);
  if (SM == HIGH) {
    if (SL == LOW && SR == HIGH) {  // Αν ανιχνευτεί μαύρο στα δεξιά και λευκό στα αριστερά, στρίβει δεξιά
      turnR();
    } else if (SR == LOW && SL == HIGH) {  // αν ανιχνευτεί μαύρο στα αριστερά και λευκό στα δεξιά, στρίβει αριστερά
      turnL();
    } else {  // Αν ανιχνευτεί λευκό και στις δύο άκρες, κινείται ευθεία
      advance();
    }
  } else {
    if (SL == LOW && SR == HIGH) {  // Αν ανιχνευτεί μαύρο στα δεξιά και λευκό στα αριστερά, στρίβει δεξιά
      turnR();
    } else if (SR == LOW && SL == HIGH) {  // Αν ανιχνευτεί μαύρο στα αριστερά και λευκό στα δεξιά, στρίβει αριστερά
      turnL();
    } else {  // Αν όλοι οι σένσορες ανιχνεύουν λευκό, το αυτοκίνητο σταματάει.
      stop();
    }
  }
}

void advance()  // Κίνηση μπροστά
{
  pwm.setPWM(0, 0, speed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, speed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, speed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, speed);
  pwm.setPWM(7, 0, 0);
}

void turnR()  // Στροφή δεξιά
{
  pwm.setPWM(0, 0, turnSpeed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, turnSpeed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, turnSpeed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, turnSpeed);
}

void turnL()  // Στροφή αριστερά
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, turnSpeed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, turnSpeed);
  pwm.setPWM(4, 0, turnSpeed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, turnSpeed);
  pwm.setPWM(7, 0, 0);
}

void stop()  // Σταματάει
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, 0);
}

void back()  // Κίνηση προς τα πίσω
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, speed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, speed);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, speed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, speed);
}