#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x47);
int BUZZER_PIN = 2;    // Ορισμός βομβητή στο PIN 2
int speed = 2000;      // Αρχικοποίηση της τιμής ταχύτητας
int turnSpeed = 2000;  // Αρχικοποίηση της τιμής ταχύτητας για τις στροφές
int echoPin = 13;      // Ορισμός μονάδα υπερήχων ECHO στο D13
int trigPin = 12;      // Ορισμός μονάδα υπερήχων TRIG στο D12

int Ultrasonic_Ranging() {
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  int distance = pulseIn(echoPin, HIGH);  // Ανάγνωση της διάρκειας των υψηλών επιπέδων
  distance = distance / 58;               // Μετατροπή του χρόνου παλμού σε απόσταση
  delay(50);
  return distance;

  }
void setup() {
  Serial.begin(9600);           // Έναρξη σειριακής θύρας στη συχνότητα 9600
  pwm.begin();
  pwm.setPWMFreq(60);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  stop();
}

void loop() {
  int distance = Ultrasonic_Ranging();
  Serial.print("distance=");
  Serial.println(distance);
  if (distance < 30) {    // Αν η απόσταση αντικειμένου από τον αισθητήρα είναι λιγότερη από 30 εκατοστά
    if (distance < 15) {  // Αν η απόσταση αντικειμένου από τον αισθητήρα είναι λιγότερη από 15 εκατοστά
      digitalWrite(BUZZER_PIN, HIGH); // Ο βομβητής ενεργοποιείται
      stop();
      delay(100);
      digitalWrite(BUZZER_PIN, LOW); // Ο βομβητής απενεργοποιείται
    }else {
      stop();
      delay(100);
      turnL();
      delay(500);
    }
  }else {
    advance();
  }
}

void advance()  // Κίνηση μπροστά
{
  pwm.setPWM(0, 0, speed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, speed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, speed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, speed);
  pwm.setPWM(7, 0, 0);
}

void turnR()  // Στροφή δεξιά
{
  pwm.setPWM(0, 0, turnSpeed);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, turnSpeed);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);

    pwm.setPWM(5, 0, turnSpeed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, turnSpeed);
}

void turnL()  // Στροφή αριστερά
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, turnSpeed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, turnSpeed);
  pwm.setPWM(4, 0, turnSpeed);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, turnSpeed);
  pwm.setPWM(7, 0, 0);
}

void stop()  // Σταματάει
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, 0);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, 0);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, 0);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, 0);
}

void back()  // Κίνηση προς τα πίσω
{
  pwm.setPWM(0, 0, 0);
  pwm.setPWM(1, 0, speed);
  pwm.setPWM(2, 0, 0);
  pwm.setPWM(3, 0, speed);
  pwm.setPWM(4, 0, 0);
  pwm.setPWM(5, 0, speed);
  pwm.setPWM(6, 0, 0);
  pwm.setPWM(7, 0, speed);
}
