/*
 Δραστηριότητα 1.48
 Έλεγχος Σερβοκινητήρων βραχίονα μέσω Bluetooth
*/
#include <Servo.h>
Servo myservo1;
Servo myservo2;
Servo myservo3;
int k1 = 80, k2 = 120, k3 = 90;  // Αρχικοποίηση των τιμών των σερβοκινητήρων

void setup() {
  Serial.begin(9600);
  myservo1.attach(11);
  myservo2.attach(10);
  myservo3.attach(9);
  myservo1.write(k1);
  delay(1000);
  myservo2.write(k2);
  delay(1000);
  myservo3.write(k3);
  delay(1000);
}

void loop() {
  if (Serial.available() > 0) {  // Λήψη σημάτων Bluetooth
    switch (Serial.read()) {
      case 'f':
        while ('f') {  // Ο βραχίονας ανυψώνεται
          servo2up();
          if (Serial.read() == 's') break;
        }
        break;
      case 'b':
        while ('b') {  // Ο βραχίονας χαμηλώνει
          servo2down();
          if (Serial.read() == 's') break;
        }
        break;
      case 'l':
        while ('l') {  // Ο βραχίονας στρέφεται προς τα αριστερά
          servo3left();
          if (Serial.read() == 's') break;
        }
        break;
      case 'r':
        while ('r') {  // Ο βραχίονας στρέφεται προς τα δεξιά
          servo3right();
          if (Serial.read() == 's') break;
        }
        break;
      case 'Q':
        while ('Q') {  // Η δαγκάνα ανοίγει
          servo1on();
          if (Serial.read() == 's') break;
        }
        break;
      case 'E':
        while ('E') {  // Η δαγκάνα κλείνει
          servo1off();
          if (Serial.read() == 's') break;
        }
        break;
    }
  }
}

void servo1on() {
  myservo1.write(k1);  // Περιστρέφει το K1
  k1 -= 1;
  delay(5);
  if (k1 < 20) k1 = 20;  // Ελάχιστη περιστροφή 20°
}
void servo1off() {
  myservo1.write(k1);  // Περιστρέφει το K1
  k1 += 1;
  delay(5);
  if (k1 > 80) k1 = 80;  // Μέγιστη περιστροφή 80°
}
void servo2up() {
  myservo2.write(k2);  // Περιστρέφει το K2
  k2 += 1;
  delay(10);
  if (k2 > 120) k2 = 120;  // Μέγιστη περιστροφή 120°
}
void servo2down() {
  myservo2.write(k2);  // Περιστρέφει το K2
  k2 -= 1;
  delay(10);
  if (k2 < 10) k2 = 10;  // Ελάχιστη περιστροφή 10°
}
void servo3left() {
  myservo3.write(k3);  // Περιστρέφει το K3
  k3 += 1;
  delay(10);
  if (k3 > 180) k3 = 180;  // Μέγιστη περιστροφή 180°
}
void servo3right() {
  myservo3.write(k3);  // Περιστρέφει το K3
  k3 -= 1;
  delay(10);
  if (k3 < 1) k3 = 0;  // Ελάχιστη περιστροφή 0°
}