/*
 Δραστηριότητα 1.50
 Λειτουργία Μνήμης (2)
*/
#include <Servo.h>
Servo myservo1;                  // ορίζει τον σερβοκινητήρα της δαγκάνας
Servo myservo2;                  // ορίζει τον σερβοκινητήρα 2
Servo myservo3;                  // ορίζει τον σερβοκινητήρα της βάσης
int k1 = 80, k2 = 120, k3 = 90;  // αρχικοποίηση της τιμής γωνίας των σερβοκινητήρων
int M1[20], M2[20], M3[20];      // χρησιμοποιείται για την αποθήκευση της τιμής της γωνίας ανάγνωσης
int i = 0, j = 0, t = 0;         // i χρησιμοποιείται για την αποθήκευση του πίνακα, j για την αποθήκευση της μέγιστης τιμής, t για τον βρόχο while

void setup() {
  Serial.begin(9600);  // Ορισμός ρυθμού baud σε 9600
  myservo1.attach(11);
  myservo2.attach(10);
  myservo3.attach(9);
  myservo1.write(k1);
  delay(1000);
  myservo2.write(k2);
  delay(1000);
  myservo3.write(k3);
  delay(1000);
}

void loop() {
  if (Serial.available() > 0) {  // Λήψη σημάτων Bluetooth
    switch (Serial.read()) {
      case 'f':
        while ('f') {  // Ο βραχίονας ανυψώνεται
          servo2up();
          if (Serial.read() == 's') break;
        }
        break;
      case 'b':
        while ('b') {  // Ο βραχίονας χαμηλώνει
          servo2down();
          if (Serial.read() == 's') break;
        }
        break;
      case 'l':
        while ('l') {  // ο βραχίονας στρέφεται προς τα αριστερά
          servo3left();
          if (Serial.read() == 's') break;
        }
        break;
      case 'r':
        while ('r') {  // ο βραχίονας στρέφεται προς τα δεξιά
          servo3right();
          if (Serial.read() == 's') break;
        }
        break;
      case 'Q':
        while ('Q') {  // Η δαγκάνα ανοίγει
          servo1on();
          if (Serial.read() == 's') break;
        }
        break;
      case 'E':
        while ('E') {  // Η δαγκάνα κλείνει
          servo1off();
          if (Serial.read() == 's') break;
        }
        break;
      case 't':
        {
          M1[i] = myservo1.read();  // αποθήκευση της τιμής της γωνίας των σερβοκινητήρων σε πίνακα
          delay(100);
          M2[i] = myservo2.read();
          delay(100);
          M3[i] = myservo3.read();
          delay(100);
          i++;    // i προσθέτει 1
          j = i;  // ορίζει την τιμή του i στο j
          delay(200);
        }
        break;
      case 'i':
        {
          i = 0;
          t = 1;                 // εισαγωγή βρόχου while
          k1 = myservo1.read();  // διαβάζει τις τιμές των γωνιών και τις θέτει στην ανάλογη μεταβλητή
          k2 = myservo2.read();
          k3 = myservo3.read();
          while (t) {
            for (int k = 0; k < j; k++) {  // επανάληψη j φορές
              if (k1 < M1[k]) {            // εάν η τρέχουσα τιμή γωνίας του σερβοκινητήρα 1 είναι μικρότερη από την τιμή του πίνακα 1
                while (k1 < M1[k]) {       // ο σερβοκινητήρας περιστρέφεται στη θέση όπου είναι αποθηκευμένος στον πίνακα
                  myservo1.write(k1);      // ο σερβοκινητήρας 1 εκτελεί την κίνηση
                  k1++;                    // K1 προσθέτει 1
                  delay(10);               // καθυστέρηση για 10ms / έλεγχος της ταχύτητας περιστροφής του σερβοκινητήρα
                }
              } else {                 // όταν η τιμή της γωνίας του σερβοκινητήρα 1 είναι μεγαλύτερη από την τιμή που έχει αποθηκευτεί στον πίνακα 1
                while (k1 > M1[k]) {   // ο σερβοκινητήρας περιστρέφεται στη θέση όπου είναι αποθηκευμένος στον πίνακα
                  myservo1.write(k1);  // ο σερβοκινητήρα 1 εκτελεί την κίνηση
                  k1--;                // k1 αφαιρεί 1
                  delay(10);           // καθυστέρηση για 10ms / έλεγχος της ταχύτητας περιστροφής του σερβοκινητήρα
                }
              }
              // το ίδιο παρακάτω
              if (k2 < M2[k]) {
                while (k2 < M2[k]) {
                  myservo2.write(k2);
                  k2++;
                  delay(10);
                }
              } else {
                while (k2 > M2[k]) {
                  myservo2.write(k2);
                  k2--;
                  delay(10);
                }
              }
              if (k3 < M3[k]) {
                while (k3 < M3[k]) {
                  myservo3.write(k3);
                  k3++;
                  delay(10);
                }
              } else {
                while (k3 > M3[k]) {
                  myservo3.write(k3);
                  k3--;
                  delay(10);
                }
              }
            }
            if (Serial.read() == 't') {  // έξοδος από τον βρόχο while
              t = 0;
              break;
            }
          }
        }
        break;
    }
  }
}

void servo1on() {
  myservo1.write(k1);
  k1 -= 1;
  delay(5);
  if (k1 < 20) k1 = 20;
}
void servo1off() {
  myservo1.write(k1);
  k1 += 1;
  delay(5);
  if (k1 > 80) k1 = 80;
}
void servo2up() {
  myservo2.write(k2);
  k2 += 1;
  delay(10);
  if (k2 > 120) k2 = 120;
}
void servo2down() {
  myservo2.write(k2);
  k2 -= 1;
  delay(10);
  if (k2 < 10) k2 = 10;
}
void servo3left() {
  myservo3.write(k3);
  k3 += 1;
  delay(10);
  if (k3 > 180) k3 = 180;
}
void servo3right() {
  myservo3.write(k3);
  k3 -= 1;
  delay(10);
  if (k3 < 1) k3 = 0;
}